<?
/************************************************************************
 * Web Tools (WT) - a collection of web hosting tools                   *
 * Module HTPWD - .htpassword files managment                           *
 * Copyright (C) 2000-2004 Colin Verot - colin@verot.net                *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful, but  *
 * WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    *
 * General Public License for more details.                             *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 *    Free Software Foundation, Inc.                                    *
 *    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.         *
 ************************************************************************/
 
 // defines the config file path and name
$wt_cfg_config_file = $wt_section . ".cfg"; 

?>

<center>
<h2><? echo $wt_title; ?></h2>


<?// reads the config file, and carries on only if file is accessible
if (wt_read_cfg_file()) {

    if ($wt_action=="cfgadd") { // --------------------------------- add cfg item --------
        
        $wt_filename    = trim(wt_init_var('filename'));
        
        if (empty($wt_filename)) {
            wt_error("filename is empty");
        } else if (wt_is_valid_path($wt_filename)) {
            wt_error("filename contains bad characters");
        } else {
            wt_msg("file '$wt_filename' added successfuly in the configuration file");
            $wt_cfg_item[count($wt_cfg_item)] = $wt_filename;
            wt_update_cfg_file();
        }
        // we added the file; we get the list again
        $wt_action="";
    }

    if ($wt_action=="cfgdel") { // --------------------------------- del cfg item --------
 
        $wt_item_id     = wt_init_var('id');

        wt_msg("file '" . $wt_cfg_item[$wt_item_id] . "' deleted successfuly from the configuration file");
        $wt_cfg_item[$wt_item_id] = '';
        wt_update_cfg_file();

        // we deleted the file; we get the list again
        $wt_action="";
    }
  
    if ($wt_action=="adduser") { // --------------------------------- add user --------
 
        $wt_pwd_file_id = wt_init_var('id');
        $wt_username    = wt_init_var('username');
        $wt_password    = wt_init_var('password');
        
        if(wt_read_passwd_file($wt_pwd_file_id)) {
            if (wt_is_user($wt_username)) {
                wt_error("user '$wt_username' already exists");
            } else if (empty($wt_username)) {
                wt_error("username is empty");
            } else if (wt_is_valid_string($wt_username)) {
                wt_error("username contains bad characters");
            } else if (wt_is_valid_string($wt_password)) {
                wt_error("password contains bad characters");
            } else {
                wt_msg("user '$wt_username' added successfuly");
                $wt_user_id = count($wt_pwd_file);
                $wt_pwd_file[$wt_user_id][username] = $wt_username;
                $wt_pwd_file[$wt_user_id][password] = wt_crypt_password($wt_password);
                wt_write_passwd_file($wt_pwd_file_id);
                wt_read_passwd_file($wt_pwd_file_id);
            }
            // we added the user; we can browse the file again
            $wt_action="browse";
        }
    }

    if ($wt_action=="edituser") { // --------------------------------- edit user --------
 
        $wt_pwd_file_id = wt_init_var('id');
        $wt_user_id     = wt_init_var('userid');
        $wt_password    = trim(wt_init_var('password'));

        if(wt_read_passwd_file($wt_pwd_file_id)) {
            if (!wt_is_user($wt_pwd_file[$wt_user_id][username])) {
                wt_error("no such user (UserID: $wt_user_id)");
            } else if (empty($wt_password)) {
                wt_error("password is empty");
            } else if (wt_is_valid_string($wt_password)) {
                wt_error("password contains bad characters");
            } else {
                wt_msg("user '".$wt_pwd_file[$wt_user_id][username]."' updated successfuly");
                $wt_pwd_file[$wt_user_id][password] = wt_crypt_password($wt_password);
                wt_write_passwd_file($wt_pwd_file_id);
                wt_read_passwd_file($wt_pwd_file_id);
            }
            // we updated the user; we can browse the file again
            $wt_action="browse";
        }
    }

    if ($wt_action=="deluser") { // --------------------------------- del user --------
 
        $wt_pwd_file_id     = wt_init_var('id');
        $wt_user_id         = wt_init_var('userid');
        if (wt_read_passwd_file($wt_pwd_file_id)) {
            if (!wt_is_user($wt_pwd_file[$wt_user_id][username])) {
                wt_error("no such user (UserID: $wt_user_id)");
            } else {
                wt_msg("user '" . $wt_pwd_file[$wt_user_id][username] . "' deleted successfuly");
                $wt_pwd_file[$wt_user_id][username] = '';
                $wt_pwd_file[$wt_user_id][password] = '';
                wt_write_passwd_file($wt_pwd_file_id);
                wt_read_passwd_file($wt_pwd_file_id);
            }
            // we deleted the user; we can browse the file again
            $wt_action="browse";
        }
    }

	if ($wt_action=="browse") { // --------------------------------- browse --------

        $wt_pwd_file_id = wt_init_var('id');
        if (wt_read_passwd_file($wt_pwd_file_id)) {
?>
  <script language="JavaScript">
        function wt_del_user(userid) {
    <? /*        document.form_edit.checksubmit.value = "";  */ ?>
            cf = confirm("Are you sure you want to delete this user?");
            if (cf) {
                document.location = "<? echo $PHP_SELF; ?>?section=<? echo $wt_section; ?>&action=deluser&id=<?php echo $wt_pwd_file_id ?>&userid="+userid+"";
    <? /*            document.form_edit.checksubmit.value = "nosubmit"; */ ?>
            }
        }
    <? /*    
        function wt_check_submit() {
        	if(document.form_edit.checksubmit.value == "nosubmit") {
        		return false;
        	}
            return true;
        } */ ?>
  </script>
  <table border="0" cellspacing="0" cellpadding="5">
    <tr>
      <td colspan="3" align="center"><h3><?php echo $wt_cfg_item[$wt_pwd_file_id] ?></h3></td>
    </tr>
    <tr>
      <td class="top">user</td>
      <td class="top">password</td>
      <td class="top">actions</td>
    </tr>
<?
            $wt_col = 1; $wt_cpt = 0;
            for ($wt_user_id = 0; $wt_user_id < count($wt_pwd_file); $wt_user_id++) {
                if (!empty($wt_pwd_file[$wt_user_id][username])) {
                    $wt_cpt++;
                    echo "<form name=\"form_edit" . $wt_cpt . "\" action=\"" . $PHP_SELF . "\"><tr>";
                    echo "<td class=\"line" . $wt_col . "\"> ".$wt_pwd_file[$wt_user_id][username]."</td>";
                    //echo "<td class=\"line" . $wt_col . "\">".wt_crypt_password($wt_pwd_file[$wt_user_id][password])."</td>";
                    echo "<td class=\"line" . $wt_col . "\"><input type=\"text\" name=\"password\" class=\"table\"></td>";
                    echo "<input type=\"hidden\" name=\"section\" value=\"$wt_section\">";
                    echo "<input type=\"hidden\" name=\"action\" value=\"edituser\">";
                    echo "<input type=\"hidden\" name=\"checksubmit\" value=\"\">";
                    echo "<input type=\"hidden\" name=\"id\" value=\"" . $wt_pwd_file_id . "\">";
                    echo "<input type=\"hidden\" name=\"userid\" value=\"" . $wt_user_id . "\">";
                    echo "<td class=\"line" . $wt_col . "\"><input type=\"submit\" name=\"submit\" value=\"update\" class=\"submit\">";
                    //echo "&nbsp;<input type=\"submit\" name=\"delete\" value=\"delete\" class=\"submit\" OnSubmit=\"javascript:wt_del_user('$wt_user_id')\">";
                    echo "&nbsp;<a class=\"small\" href=\"javascript:wt_del_user('$wt_user_id')\">delete</a>";
                    echo "</td>";
                    echo "</form></tr>";
                }
                $wt_col++; if ($wt_col==3) $wt_col=1;         
            }  
            // add a line to add an user
            echo "<form name=\"form_add\" action=\"" . $PHP_SELF . "\"><tr>";
            echo "<td class=\"line" . $wt_col . "\"><input type=\"text\" name=\"username\" class=\"table\"></td>";
            echo "<td class=\"line" . $wt_col . "\"><input type=\"text\" name=\"password\" class=\"table\"></td>";
            echo "<td class=\"line" . $wt_col . "\"><input type=\"hidden\" name=\"section\" value=\"$wt_section\">";
            echo "<input type=\"hidden\" name=\"action\" value=\"adduser\">";
            echo "<input type=\"hidden\" name=\"id\" value=\"" . $wt_pwd_file_id . "\">";
            echo "<input type=\"submit\" name=\"submit\" value=\"add\" class=\"submit\"></td>";
            echo "</tr></form>";
        }
?>
  </table>
   
<?
    } else if ($wt_action=="view") { // --------------------------------- view --------
        $wt_pwd_file_id              = wt_init_var('id');
        if (wt_read_passwd_file($wt_pwd_file_id)) {
?>
  <table border="0" cellspacing="0" cellpadding="5">
    <tr>
      <td align="center"><h3><?php echo $wt_cfg_item[$wt_pwd_file_id] ?></h3></td>
    </tr>
    <tr>
      <td class="box"><pre><? include $wt_cfg_item[$wt_pwd_file_id] ?></pre></td>
    </tr>
  </table>
  
<?      }          
    }
    
    if ($wt_action=="create") { // --------------------------------- create file --------
 
        $wt_item_id     = wt_init_var('id');

        wt_msg("creating ".$wt_cfg_item[$wt_item_id]."...");
        if (!($wt_file_handle = @fopen($wt_cfg_item[$wt_item_id], "w"))) {
            wt_error($wt_cfg_item[$wt_item_id] . " can't be created");
        } else {
            fclose($wt_file_handle);
            wt_msg("... done");
        } 

        // we get the list again
        $wt_action="";
    }  


	if (!isset($wt_action) || $wt_action == "") {  // --------------------------------- MAIN --------
?>  
  <script language="JavaScript">
        function wt_cfg_del(id) {
            cf = confirm("Are you sure you want to remove this .htpassword from the list (it actually doesn't delete any file on disk)?");
            if (cf) {
                document.location = "<? echo $PHP_SELF; ?>?section=<? echo $wt_section; ?>&action=cfgdel&id="+id+"";
            }
        }
  </script>
  <table border="0" cellspacing="0" cellpadding="5">
    <tr>
      <td class="top">.htpassword file</td>
      <td class="top">status</td>
      <td class="top">action</td>
    </tr>
<?
        $wt_col=1;
        for ($wt_cpt = 0; $wt_cpt < count($wt_cfg_item); $wt_cpt++) {
            if (!empty($wt_cfg_item[$wt_cpt])) {
                echo "<tr>";
    	        echo "<td class=\"line" . $wt_col . "\">".$wt_cfg_item[$wt_cpt]."</td>";
    	        $wt_init = wt_init_passwd_file($wt_cfg_item[$wt_cpt]);
    	        if ($wt_init == "OK") { 
    	            echo "<td class=\"line" . $wt_col . "\" align=\"center\"><span class=\"ok\">OK</span></td>";
        	        echo "<td class=\"line" . $wt_col . "\"><a class=\"small\" href=\"" . $PHP_SELF . "?section=$wt_section&action=browse&id=$wt_cpt\">browse</a>&nbsp;";
    	        } else {
    	            echo "<td class=\"line" . $wt_col . "\"><span class=\"bad\">$wt_init!</span></td>";
        	        echo "<td class=\"line" . $wt_col . "\">";
        	        if ($wt_init == "missing") echo "<a class=\"small\" href=\"" . $PHP_SELF . "?section=$wt_section&action=create&id=$wt_cpt\">create</a>&nbsp;";
                }	                    
        	    echo "<a class=\"small\" href=\"javascript:wt_cfg_del('$wt_cpt')\">remove</a></td>";
    	        echo "</tr>";
    	        $wt_col++; if ($wt_col==3) $wt_col=1;
            }    
        }
        // add a line to add an file
        echo "<form name=\"form_add\" action=\"" . $PHP_SELF . "\"><tr>";
        echo "<td colspan=\"2\" class=\"line" . $wt_col . "\"><input size =\"40\" type=\"text\" name=\"filename\" class=\"table\"></td>";
        echo "<td class=\"line" . $wt_col . "\"><input type=\"hidden\" name=\"section\" value=\"$wt_section\">";
        echo "<input type=\"hidden\" name=\"action\" value=\"cfgadd\">";
        echo "<input type=\"submit\" name=\"submit\" value=\"add\" class=\"submit\"></td>";
        echo "</tr></form>";  
?>
  </table>
  
<? 	} else if (!$wt_error_occured){  // --------------------------------- nav --------
        echo "<br /><p class=\"small\">";
        // echo "<a href=\"" . $PHP_SELF . "?section=$wt_section\">main</a> | ";
        if ($wt_action == "view") {
            echo "<a href=\"" . $PHP_SELF . "?section=$wt_section&action=browse&id=$wt_pwd_file_id\">browse file</a> ";
        } else {
            echo "<a href=\"" . $PHP_SELF . "?section=$wt_section&action=view&id=$wt_pwd_file_id\">view .htpasswd file</a> ";
        }
        echo "</p>";  
    } 
?>
</center>

<?
}

function wt_init_passwd_file($wt_file) {
    if (!file_exists($wt_file)) return "missing";
    if (!is_readable($wt_file)) return "not readable";
    if (!is_writeable($wt_file)) return "not writeable";
    return "OK";
}

function wt_read_passwd_file($wt_pwd_file_num) {
    global $wt_cfg_item, $wt_pwd_file;
    $wt_pwd_file = array();
    $wt_res = wt_init_passwd_file($wt_cfg_item[$wt_pwd_file_num]);
    if ($wt_res == "OK") {
        if (!($wt_file_handle = @fopen($wt_cfg_item[$wt_pwd_file_num], "r"))) {
            wt_error("could not read ".$wt_cfg_item[$wt_pwd_file_num]." file");
            return false;
        }
        $wt_cpt = 0;
        while (!feof($wt_file_handle)) {
            $wt_file_line = fgets($wt_file_handle, 512);
            $wt_file_line = trim($wt_file_line);
            $wt_file_data = explode(":", $wt_file_line);
            $wt_file_data[0] = trim($wt_file_data[0]);
            $wt_file_data[1] = chop(trim($wt_file_data[1]));
            if (empty($wt_file_line) || $wt_file_line[0] == '#' || $wt_file_line[0] == '*' ||	empty($wt_file_data[0]) || empty($wt_file_data[1])) 
                continue;
            $wt_pwd_file[$wt_cpt][username] = $wt_file_data[0];
            $wt_pwd_file[$wt_cpt][password] = $wt_file_data[1];
            $wt_cpt++;
        }
        fclose($wt_file_handle);
        return true;
    } else {
        wt_error(".htpassword file " . $wt_cfg_item[$wt_pwd_file_num] . " is " . $wt_res);
        return false;
    }
}

function wt_write_passwd_file($wt_pwd_file_num) {
    global $wt_cfg_item, $wt_pwd_file;
    $wt_res = wt_init_passwd_file($wt_cfg_item[$wt_pwd_file_num]);
    if ($wt_res == "OK") {
        if (!($wt_file_handle = @fopen($wt_cfg_item[$wt_pwd_file_num], "w"))) {
            wt_error("could not write ".$wt_cfg_item[$wt_pwd_file_num]." file");
            return false;
        }
        for ($wt_cpt = 0; $wt_cpt < count($wt_pwd_file); $wt_cpt++) {
            if (!empty($wt_pwd_file[$wt_cpt][username]))
                fwrite($wt_file_handle, $wt_pwd_file[$wt_cpt][username].":".
		            $wt_pwd_file[$wt_cpt][password]."\n");
        }
        fclose($wt_file_handle);
        return true;
    } else {
        wt_error(".htpassword file " . $wt_cfg_item[$wt_pwd_file_num] . " is " . $wt_res);
        return false;
    }
}

function wt_is_user($wt_username) {
    global $wt_pwd_file;
    if (empty($wt_username)) return false;
    for ($wt_cpt = 0; $wt_cpt < count($wt_pwd_file); $wt_cpt++) {
        if ($wt_pwd_file[$wt_cpt][username] == $wt_username) return true;
    }
    return false;
}

function wt_random() {
    srand ((double) microtime() * 1000000);
    return rand();
}

function wt_crypt_password($wt_password) {
    if (empty($wt_password)) return "EMPTY PASSWORD";
    $wt_salt = wt_random();
    $wt_salt = substr($wt_salt, 0, 2);
    return crypt($wt_password, $wt_salt);
}


?>
